/* Program Name: deccolor.c  
* Author: Paul McDonald
* Creator of the Breeze Windowing Library
*------------------------------------------------------------------------* 
* Created: 8/24/1988 at 17:19 
* Called From:  v_putstr()  
*                 
*                 
* 	 Modified slightly by Chuck Forsyth
*                 
*                 
*                 
*........................................................................* 
* Revision: 1.0 Last Revised: 8/24/1988 at 17:19
* Description: Original Creation.
*.........................................................................
*---------------------------- ALL RIGHTS RESERVED -----------------------*/

#define UPPER        ('a' - 'A')
#define islower(p)   ( 'a' <= (p) && (p) <= 'z' )
#define toupper(p)   ( islower(p) ? ((p) - UPPER) : ((p)) )

int   deccolor(colorstr)

char  *colorstr;

{

char  convcol,
      foregrnd,
      intense,
      inverse,
      blink,
      underln,
      slash_id,
      *col_ptr;

col_ptr = colorstr;
/*
 * This pass was eliminated by putting it in the main while loop
 *
while(*col_ptr){
   *col_ptr = toupper(*col_ptr);
   ++col_ptr;
}
*/
col_ptr = colorstr;

convcol = 0;

inverse = 0;
intense = 0;
blink = 0;
underln = 0;
foregrnd = 0;
slash_id = 0;


while(*col_ptr = toupper(*col_ptr) ){

   if(*col_ptr ==  'B' && *(col_ptr + 1) == 'G'){
      convcol |=3;
      col_ptr +=2;
   }else{
      if(*col_ptr == 'R'  && *(col_ptr + 1) == 'B'){
         convcol |= 5;
         col_ptr +=2;
      }else{
         if(*col_ptr == 'G' && *(col_ptr + 1) == 'R'){
            convcol |= 6;
            col_ptr +=2;
         }else{
            switch((int)*col_ptr){
               case  78:               /* N */
                  convcol |= 0;
                  break;
               case  85:               /* U */
                  underln = 1;
                  break;
               case  66:               /* B */
                  convcol |= 1;
                  break;
               case 71:                /* G */
                  convcol |=2;
                  break;
               case 82:                /* R */
                  convcol |=4;
                  break;
               case 87:
                  convcol |=7;         /* W */
                  break;
               case 42:
                  blink = 128;       /* blinking */
                  break;
               case 43:
                  intense = 8;         /* high intensity */
                  break;
               case 73:                /* inverse */
                  inverse = 0x070;
                  break;
            }
            ++col_ptr;
         }
      }
   }

   if(*col_ptr == '/'){
      slash_id = 1;
      foregrnd = convcol;
      convcol = 0;
      ++col_ptr;
   }

}

if(slash_id){
   convcol = (convcol << 4) & 240;
   slash_id = 0;
}

convcol |= foregrnd;

if(inverse)
   convcol = inverse;

if(intense)
   convcol |= intense;

if(blink)
   convcol |= blink;

if(underln)
   convcol |= underln;

return((int)convcol);

}
